<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Predefined Types</TITLE>
<link href="suif1_69.html" rel=Next>
<link href="suif1_67.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_67.html">previous</A>, <A HREF="suif1_69.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC68" HREF="suif1_toc.html#TOC68">Predefined Types</A></H2>
<P>
<A NAME="IDX511"></A>
<A NAME="IDX512"></A>

</P>
<P>
The global symbol table (see section <A HREF="suif1_42.html#SEC42">The Global Symbol Table</A>) is initialized
with some predefined types.  The SUIF library also defines a number of
variables containing pointers to these predefined types, so that you
don't need to search the symbol tables for most commonly-used types.
The first set of predefined types are fixed-size scalar types:

</P>
<DL COMPACT>

<DT><CODE>type_v0</CODE>
<DD>
<A NAME="IDX513"></A>
This is a <CODE>void</CODE> type with size zero.

<DT><CODE>type_s8</CODE>
<DD>
<A NAME="IDX514"></A>
<DT><CODE>type_s16</CODE>
<DD>
<A NAME="IDX515"></A>
<DT><CODE>type_s32</CODE>
<DD>
<A NAME="IDX516"></A>
<DT><CODE>type_s64</CODE>
<DD>
<A NAME="IDX517"></A>
These are signed integer types of 8, 16, 32, and 64 bits.

<DT><CODE>type_u8</CODE>
<DD>
<A NAME="IDX518"></A>
<DT><CODE>type_u16</CODE>
<DD>
<A NAME="IDX519"></A>
<DT><CODE>type_u32</CODE>
<DD>
<A NAME="IDX520"></A>
<DT><CODE>type_u64</CODE>
<DD>
<A NAME="IDX521"></A>
These are unsigned integer types of 8, 16, 32, and 64 bits.

<DT><CODE>type_f32</CODE>
<DD>
<A NAME="IDX522"></A>
<DT><CODE>type_f64</CODE>
<DD>
<A NAME="IDX523"></A>
<DT><CODE>type_f128</CODE>
<DD>
<A NAME="IDX524"></A>
These are floating-point types of 32, 64, and 128 bits.

<DT><CODE>type_error</CODE>
<DD>
<A NAME="IDX525"></A>
This variable is just set to <CODE>NULL</CODE>.  It may be used to represent
various error conditions.
</DL>

<P>
Because the fixed-size types do not necessarily match the target machine
parameters (see section <A HREF="suif1_103.html#SEC103">Target Machine Parameters</A>), they should rarely be
used.  Instead the SUIF library also predefines pointers to types that
correspond to the most common C types.  These "portable" types are
automatically initialized using the target machine parameters.

</P>
<DL COMPACT>

<DT><CODE>type_void</CODE>
<DD>
<A NAME="IDX526"></A>
Since <CODE>void</CODE> types always have a size of zero, this type is
equivalent to <CODE>type_v0</CODE>, but it is included for completeness.

<DT><CODE>type_ptr</CODE>
<DD>
<A NAME="IDX527"></A>
This type is a pointer to <CODE>type_void</CODE>.  Like all other pointer
types, it automatically has the size of pointers on the target machine.

<DT><CODE>type_char</CODE>
<DD>
<A NAME="IDX528"></A>
This is an integer type with the size specified for <CODE>C_char</CODE> types
in the target machine parameters.  The <CODE>char_is_signed</CODE> machine
parameter determines whether it is signed or unsigned.

<DT><CODE>type_signed_char</CODE>
<DD>
<A NAME="IDX529"></A>
<DT><CODE>type_unsigned_char</CODE>
<DD>
<A NAME="IDX530"></A>
These are signed and unsigned integer types with the size specified for
<CODE>C_char</CODE> types in the target machine parameters.

<DT><CODE>type_signed_short</CODE>
<DD>
<A NAME="IDX531"></A>
<DT><CODE>type_unsigned_short</CODE>
<DD>
<A NAME="IDX532"></A>
These are signed and unsigned integer types with the size specified for
<CODE>C_short</CODE> types in the target machine parameters.

<DT><CODE>type_signed</CODE>
<DD>
<A NAME="IDX533"></A>
<DT><CODE>type_unsigned</CODE>
<DD>
<A NAME="IDX534"></A>
These are signed and unsigned integer types with the size specified for
<CODE>C_int</CODE> types in the target machine parameters.

<DT><CODE>type_signed_long</CODE>
<DD>
<A NAME="IDX535"></A>
<DT><CODE>type_unsigned_long</CODE>
<DD>
<A NAME="IDX536"></A>
These are signed and unsigned integer types with the size specified for
<CODE>C_long</CODE> types in the target machine parameters.

<DT><CODE>type_signed_longlong</CODE>
<DD>
<A NAME="IDX537"></A>
<DT><CODE>type_unsigned_longlong</CODE>
<DD>
<A NAME="IDX538"></A>
These are signed and unsigned integer types with the size specified for
<CODE>C_longlong</CODE> types in the target machine parameters.

<DT><CODE>type_float</CODE>
<DD>
<A NAME="IDX539"></A>
<DT><CODE>type_double</CODE>
<DD>
<A NAME="IDX540"></A>
<DT><CODE>type_longdouble</CODE>
<DD>
<A NAME="IDX541"></A>
These are floating-point types with the sizes specified for
<CODE>C_float</CODE>, <CODE>C_double</CODE>, and <CODE>C_longdouble</CODE> types in the
target machine parameters.
</DL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_67.html">previous</A>, <A HREF="suif1_69.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
